import java.util.*;

import org.apache.commons.collections.map.AbstractReferenceMap;
import org.apache.commons.collections.map.ReferenceIdentityMap;
import org.apache.commons.collections.set.MapBackedSet;

public aspect HasNext {
	
	dependency {
		strong next;
		weak hasNext;		
	}
	
	Set calledNext = MapBackedSet.decorate(new ReferenceIdentityMap(AbstractReferenceMap.WEAK,AbstractReferenceMap.HARD,true),new Object());
	
	dependent synchronized before next(Iterator i):
	    !within(dacapo..*) &&
		!within(HasNext) && 
		call(* java.util.Iterator+.next()) && target(i) {
		if(calledNext.contains(i)) {
   		    //System.err.println("MATCHED at "+thisJoinPointStaticPart.getSourceLocation());
		} else {
			calledNext.add(i);
		}
	}

	dependent synchronized before hasNext(Iterator i):
	    !within(dacapo..*) &&
		!within(HasNext) && 
		call(* java.util.Iterator+.hasNext()) && target(i) {
		calledNext.remove(i);
	}	
	
	before(): call(* dacapo.Benchmark.run(..)) {
	    //reset all data structures for new benchmark run
		calledNext.clear();
	}	
}

//class HasNextTest {
//	
//	public static void main(String[] args) {
//		List l = new ArrayList();
//		l.add("");
//		l.add("");
//		l.add("");
//		Iterator i = l.iterator();
//		i.next();
//		if(i.hasNext()) {
//			i.next();
//		}
//		i.next();
//	}
//	
//}