import java.util.*;

import org.apache.commons.collections.map.AbstractReferenceMap;
import org.apache.commons.collections.map.ReferenceIdentityMap;
import org.apache.commons.collections.set.MapBackedSet;

public aspect HasNextElem {
	
	dependency {
		strong next;
		weak hasNext;		
	}
	
	Set calledNext = MapBackedSet.decorate(new ReferenceIdentityMap(AbstractReferenceMap.WEAK,AbstractReferenceMap.HARD,true),new Object());
	
	dependent synchronized before next(Enumeration e):
	    !within(dacapo..*) &&
		!within(HasNextElem) && 
		call(* java.util.Enumeration+.nextElement()) && target(e) {
		if(calledNext.contains(e)) {
   		    //System.err.println("MATCHED at "+thisJoinPointStaticPart.getSourceLocation());
		} else {
			calledNext.add(e);
		}
	}

	dependent synchronized before hasNext(Enumeration e):
	    !within(dacapo..*) &&
		!within(HasNextElem) && 
		call(* java.util.Enumeration+.hasMoreElements()) && target(e) {
		calledNext.remove(e);
	}	
	
	before(): call(* dacapo.Benchmark.run(..)) {
	    //reset all data structures for new benchmark run
		calledNext.clear();
	}
}
//
//class HasNextElemTest {
//	
//	public static void main(String[] args) {
//		Vector v = new Vector();
//		v.add("");
//		v.add("");
//		v.add("");
//		Enumeration e = v.elements();
//		e.nextElement();
//		if(e.hasMoreElements()) {
//			e.nextElement();
//		}
//		e.nextElement();
//	}
//	
//}