/* Monitor aspect for FailSafeEnumHashtable+*/
import java.util.*;
import org.apache.commons.collections.map.*;
class FailSafeEnumHashtableMonitorPM {
	Vector monitorList = new Vector();
	synchronized public void create(Enumeration e, Hashtable v) {
		HashSet monitorSet = new HashSet();
		monitorList.add(new FailSafeEnumHashtableMonitor());
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			FailSafeEnumHashtableMonitor monitor = (FailSafeEnumHashtableMonitor)it.next();
			monitor.create(e, v);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("the enumeration was changed during iterating!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void updatesource(Hashtable v) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			FailSafeEnumHashtableMonitor monitor = (FailSafeEnumHashtableMonitor)it.next();
			monitor.updatesource(v);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("the enumeration was changed during iterating!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void next(Enumeration e) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			FailSafeEnumHashtableMonitor monitor = (FailSafeEnumHashtableMonitor)it.next();
			monitor.next(e);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("the enumeration was changed during iterating!");
				}
			} // for else
		} // for while
	} // end of method
}
class FailSafeEnumHashtableMonitor {
	/* %%_%_ERE_%_%% */
	int state = 0;
	public int hashCode() { return state; }
	public boolean equals(Object o) {
		if (! (o instanceof FailSafeEnumHashtableMonitor)) return false;
		return state == ((FailSafeEnumHashtableMonitor)o).state;
	}
	boolean failed = false;
	boolean suceeded = false;
	public FailSafeEnumHashtableMonitor() {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
	}
	synchronized public void create(Enumeration e, Hashtable v) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		create = true;
		switch (state) {
			case 2 :
			state =  updatesource ? 2 : next ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = updatesource ? 2 : next ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void updatesource(Hashtable v) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		updatesource = true;
		switch (state) {
			case 2 :
			state =  updatesource ? 2 : next ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = updatesource ? 2 : next ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void next(Enumeration e) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		next = true;
		switch (state) {
			case 2 :
			state =  updatesource ? 2 : next ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = updatesource ? 2 : next ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public boolean suceeded(){
		return suceeded;
	}
	synchronized public void reset(){
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		state = 0;
	}
}
public aspect FailSafeEnumHashtable {
	Map makeMap(Object key){
		if (key instanceof String)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	List makeList(){
		return new ArrayList();
	}
	Map FailSafeEnumHashtable_e_v_Map = null;
	Map FailSafeEnumHashtable_v_Map = null;
	Map FailSafeEnumHashtable_e_Map = null;
	pointcut FailSafeEnumHashtable_create(Hashtable v) :  call(* Hashtable+.elements())&& target(v)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM) ||  call(* Hashtable+.keys())&& target(v)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM);
	dependent after create_FailSafeEnumHashtable(Hashtable v)  returning(Enumeration e): FailSafeEnumHashtable_create(v) {
		Object obj = null;
		FailSafeEnumHashtableMonitorPM monitor = null;
		boolean toCreate = false;
		Map m = FailSafeEnumHashtable_e_v_Map;
		if (m == null) m = FailSafeEnumHashtable_e_v_Map = makeMap(e);
		synchronized(FailSafeEnumHashtable_e_v_Map){
			obj = m.get(e);
			if (obj == null) {
				obj = makeMap(v);
				m.put(e, obj);
			}
			m = (Map)obj;
			obj = m.get(v);
			monitor = (FailSafeEnumHashtableMonitorPM)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new FailSafeEnumHashtableMonitorPM();
				m.put(v, monitor);
			}//end of if
		}//end of lookup
		if (toCreate){
			m = FailSafeEnumHashtable_v_Map;
			if (m == null) m = FailSafeEnumHashtable_v_Map = makeMap(v);
			obj = null;
			synchronized(FailSafeEnumHashtable_v_Map){
				obj = m.get(v);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(v, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
			m = FailSafeEnumHashtable_e_Map;
			if (m == null) m = FailSafeEnumHashtable_e_Map = makeMap(e);
			obj = null;
			synchronized(FailSafeEnumHashtable_e_Map){
				obj = m.get(e);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(e, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
		}//end of if
		{
			monitor.create(e, v);
		}
	}
	pointcut FailSafeEnumHashtable_updatesource(Hashtable v) :  call(* Hashtable+.put*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM) ||  call(* Hashtable+.putAll*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM) ||  call(* Hashtable+.clear())&& target(v)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM) ||  call(* Hashtable+.remove*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM);
	dependent before updatesource_FailSafeEnumHashtable(Hashtable v): FailSafeEnumHashtable_updatesource(v) {
		Object obj = null;
		FailSafeEnumHashtableMonitorPM monitor = null;
		Map m = FailSafeEnumHashtable_v_Map;
		if (m == null) m = FailSafeEnumHashtable_v_Map = makeMap(v);
		synchronized(FailSafeEnumHashtable_v_Map){
			obj = m.get(v);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (FailSafeEnumHashtableMonitorPM)monitors.next();
					{
						monitor.updatesource(v);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut FailSafeEnumHashtable_next(Enumeration e) :  call(Object Enumeration+.nextElement())&& target(e)&& !within(dacapo..*)&& !within(FailSafeEnumHashtable)&& !within(FailSafeEnumHashtableMonitor)&& !within(FailSafeEnumHashtableMonitorPM);
	dependent before next_FailSafeEnumHashtable(Enumeration e): FailSafeEnumHashtable_next(e) {
		Object obj = null;
		FailSafeEnumHashtableMonitorPM monitor = null;
		Map m = FailSafeEnumHashtable_e_Map;
		if (m == null) m = FailSafeEnumHashtable_e_Map = makeMap(e);
		synchronized(FailSafeEnumHashtable_e_Map){
			obj = m.get(e);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (FailSafeEnumHashtableMonitorPM)monitors.next();
					{
						monitor.next(e);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	//Validation dependencies
	dependency{
		strong create_FailSafeEnumHashtable , updatesource_FailSafeEnumHashtable , next_FailSafeEnumHashtable ;
	}
}
