/* Monitor aspect for WriterTest+*/import java.io.*;
import java.util.*;
import org.apache.commons.collections.map.*;
class WriterTestMonitorPM {
	Vector monitorList = new Vector();
	synchronized public void create(Writer r, OutputStream s) {
		HashSet monitorSet = new HashSet();
		monitorList.add(new WriterTestMonitor());
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestMonitor monitor = (WriterTestMonitor)it.next();
			monitor.create(r, s);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying output stream has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void closeS(OutputStream s) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestMonitor monitor = (WriterTestMonitor)it.next();
			monitor.closeS(s);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying output stream has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void closeR(Writer r) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestMonitor monitor = (WriterTestMonitor)it.next();
			monitor.closeR(r);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying output stream has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void writeS(OutputStream s) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestMonitor monitor = (WriterTestMonitor)it.next();
			monitor.writeS(s);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying output stream has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void writeR(Writer r) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestMonitor monitor = (WriterTestMonitor)it.next();
			monitor.writeR(r);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying output stream has been closed!");
				}
			} // for else
		} // for while
	} // end of method
}
class WriterTestMonitor {
	/* %%_%_ERE_%_%% */
	int state = 0;
	public int hashCode() { return state; }
	public boolean equals(Object o) {
		if (! (o instanceof WriterTestMonitor)) return false;
		return state == ((WriterTestMonitor)o).state;
	}
	boolean failed = false;
	boolean suceeded = false;
	public WriterTestMonitor() {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
	}
	synchronized public void create(Writer r, OutputStream s) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		create = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void closeS(OutputStream s) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		closeS = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void closeR(Writer r) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		closeR = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void writeS(OutputStream s) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		writeS = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void writeR(Writer r) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		writeR = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public boolean suceeded(){
		return suceeded;
	}
	synchronized public void reset(){
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		state = 0;
	}
}
class WriterTestWMonitorPM {
	Vector monitorList = new Vector();
	synchronized public void create(Writer r, Writer s) {
		HashSet monitorSet = new HashSet();
		monitorList.add(new WriterTestWMonitor());
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestWMonitor monitor = (WriterTestWMonitor)it.next();
			monitor.create(r, s);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying original writer has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void closeS(Writer s) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestWMonitor monitor = (WriterTestWMonitor)it.next();
			monitor.closeS(s);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying original writer has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void closeR(Writer r) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestWMonitor monitor = (WriterTestWMonitor)it.next();
			monitor.closeR(r);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying original writer has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void writeS(Writer s) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestWMonitor monitor = (WriterTestWMonitor)it.next();
			monitor.writeS(s);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying original writer has been closed!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void writeR(Writer r) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			WriterTestWMonitor monitor = (WriterTestWMonitor)it.next();
			monitor.writeR(r);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Cannot write the writer because the underlying original writer has been closed!");
				}
			} // for else
		} // for while
	} // end of method
}
class WriterTestWMonitor {
	/* %%_%_ERE_%_%% */
	int state = 0;
	public int hashCode() { return state; }
	public boolean equals(Object o) {
		if (! (o instanceof WriterTestWMonitor)) return false;
		return state == ((WriterTestWMonitor)o).state;
	}
	boolean failed = false;
	boolean suceeded = false;
	public WriterTestWMonitor() {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
	}
	synchronized public void create(Writer r, Writer s) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		create = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void closeS(Writer s) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		closeS = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void closeR(Writer r) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		closeR = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void writeS(Writer s) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		writeS = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public void writeR(Writer r) {
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		writeR = true;
		switch (state) {
			case 2 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 3 : writeR ? 3 : -1;
			break;
			case 0 :
			state = create ? 1 : -1;
			break;
			case 1 :
			state = closeS ? 2 : closeR ? 2 : writeS ? 1 : writeR ? 1 : -1;
			break;
			default:
			state = -1;
		}
		failed = state == -1;
		suceeded = state == 3;
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public boolean suceeded(){
		return suceeded;
	}
	synchronized public void reset(){
		boolean create = false;
		boolean closeS = false;
		boolean closeR = false;
		boolean writeS = false;
		boolean writeR = false;
		state = 0;
	}
}
public aspect WriterTest {
	Map makeMap(Object key){
		if (key instanceof String)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	List makeList(){
		return new ArrayList();
	}
	Map WriterTest_r_s_Map = null;
	Map WriterTest_s_Map = null;
	Map WriterTest_r_Map = null;
	pointcut WriterTest_create(OutputStream s) :  call( Writer+.new(OutputStream+, ..))&& args(s, ..)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestMonitor)&& !within(WriterTestMonitorPM);
	dependent after create_WriterTest(OutputStream s)  returning(Writer r): WriterTest_create(s) {
		Object obj = null;
		WriterTestMonitorPM monitor = null;
		boolean toCreate = false;
		Map m = WriterTest_r_s_Map;
		if (m == null) m = WriterTest_r_s_Map = makeMap(r);
		synchronized(WriterTest_r_s_Map){
			obj = m.get(r);
			if (obj == null) {
				obj = makeMap(s);
				m.put(r, obj);
			}
			m = (Map)obj;
			obj = m.get(s);
			monitor = (WriterTestMonitorPM)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new WriterTestMonitorPM();
				m.put(s, monitor);
			}//end of if
		}//end of lookup
		if (toCreate){
			m = WriterTest_s_Map;
			if (m == null) m = WriterTest_s_Map = makeMap(s);
			obj = null;
			synchronized(WriterTest_s_Map){
				obj = m.get(s);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(s, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
			m = WriterTest_r_Map;
			if (m == null) m = WriterTest_r_Map = makeMap(r);
			obj = null;
			synchronized(WriterTest_r_Map){
				obj = m.get(r);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(r, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
		}//end of if
		{
			monitor.create(r, s);
		}
	}
	pointcut WriterTest_closeS(OutputStream s) :  call(* OutputStream+.close())&& target(s)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestMonitor)&& !within(WriterTestMonitorPM);
	dependent after closeS_WriterTest(OutputStream s) : WriterTest_closeS(s) {
		Object obj = null;
		WriterTestMonitorPM monitor = null;
		Map m = WriterTest_s_Map;
		if (m == null) m = WriterTest_s_Map = makeMap(s);
		synchronized(WriterTest_s_Map){
			obj = m.get(s);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestMonitorPM)monitors.next();
					{
						monitor.closeS(s);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut WriterTest_closeR(Writer r) :  call(* Writer+.close())&& target(r)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestMonitor)&& !within(WriterTestMonitorPM);
	dependent after closeR_WriterTest(Writer r) : WriterTest_closeR(r) {
		Object obj = null;
		WriterTestMonitorPM monitor = null;
		Map m = WriterTest_r_Map;
		if (m == null) m = WriterTest_r_Map = makeMap(r);
		synchronized(WriterTest_r_Map){
			obj = m.get(r);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestMonitorPM)monitors.next();
					{
						monitor.closeR(r);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut WriterTest_writeS(OutputStream s) :  call(* OutputStream+.write*(..))&& target(s)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestMonitor)&& !within(WriterTestMonitorPM);
	dependent before writeS_WriterTest(OutputStream s): WriterTest_writeS(s) {
		Object obj = null;
		WriterTestMonitorPM monitor = null;
		Map m = WriterTest_s_Map;
		if (m == null) m = WriterTest_s_Map = makeMap(s);
		synchronized(WriterTest_s_Map){
			obj = m.get(s);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestMonitorPM)monitors.next();
					{
						monitor.writeS(s);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut WriterTest_writeR(Writer r) :  call(* Writer+.write*(..))&& target(r)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestMonitor)&& !within(WriterTestMonitorPM) ||  call(* Writer+.print*(..))&& target(r)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestMonitor)&& !within(WriterTestMonitorPM);
	dependent before writeR_WriterTest(Writer r): WriterTest_writeR(r) {
		Object obj = null;
		WriterTestMonitorPM monitor = null;
		Map m = WriterTest_r_Map;
		if (m == null) m = WriterTest_r_Map = makeMap(r);
		synchronized(WriterTest_r_Map){
			obj = m.get(r);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestMonitorPM)monitors.next();
					{
						monitor.writeR(r);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	//Validation dependencies
	dependency{
		strong create_WriterTest , closeS_WriterTest , writeS_WriterTest ;
		weak closeR_WriterTest , writeR_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeS_WriterTest , writeR_WriterTest ;
		weak closeR_WriterTest , writeS_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeR_WriterTest , writeS_WriterTest ;
		weak closeS_WriterTest , writeR_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeR_WriterTest , writeR_WriterTest ;
		weak closeS_WriterTest , writeS_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeS_WriterTest , closeR_WriterTest , writeS_WriterTest ;
		weak writeR_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeS_WriterTest , closeR_WriterTest , writeR_WriterTest ;
		weak writeS_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeS_WriterTest , writeS_WriterTest , writeR_WriterTest ;
		weak closeR_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeR_WriterTest , writeS_WriterTest , writeR_WriterTest ;
		weak closeS_WriterTest ;
	}
	dependency{
		strong create_WriterTest , closeS_WriterTest , closeR_WriterTest , writeS_WriterTest , writeR_WriterTest ;
	}
	Map WriterTestW_r_s_Map = null;
	Map WriterTestW_s_Map = null;
	Map WriterTestW_r_Map = null;
	pointcut WriterTestW_create(Writer s) :  call( Writer+.new(Writer+, ..))&& args(s, ..)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM);
	dependent after create_WriterTestW(Writer s)  returning(Writer r): WriterTestW_create(s) {
		Object obj = null;
		WriterTestWMonitorPM monitor = null;
		boolean toCreate = false;
		Map m = WriterTestW_r_s_Map;
		if (m == null) m = WriterTestW_r_s_Map = makeMap(r);
		synchronized(WriterTestW_r_s_Map){
			obj = m.get(r);
			if (obj == null) {
				obj = makeMap(s);
				m.put(r, obj);
			}
			m = (Map)obj;
			obj = m.get(s);
			monitor = (WriterTestWMonitorPM)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new WriterTestWMonitorPM();
				m.put(s, monitor);
			}//end of if
		}//end of lookup
		if (toCreate){
			m = WriterTestW_s_Map;
			if (m == null) m = WriterTestW_s_Map = makeMap(s);
			obj = null;
			synchronized(WriterTestW_s_Map){
				obj = m.get(s);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(s, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
			m = WriterTestW_r_Map;
			if (m == null) m = WriterTestW_r_Map = makeMap(r);
			obj = null;
			synchronized(WriterTestW_r_Map){
				obj = m.get(r);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(r, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
		}//end of if
		{
			monitor.create(r, s);
		}
	}
	pointcut WriterTestW_closeS(Writer s) :  call(* Writer+.close())&& target(s)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM);
	dependent after closeS_WriterTestW(Writer s) : WriterTestW_closeS(s) {
		Object obj = null;
		WriterTestWMonitorPM monitor = null;
		Map m = WriterTestW_s_Map;
		if (m == null) m = WriterTestW_s_Map = makeMap(s);
		synchronized(WriterTestW_s_Map){
			obj = m.get(s);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestWMonitorPM)monitors.next();
					{
						monitor.closeS(s);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut WriterTestW_closeR(Writer r) :  call(* Writer+.close())&& target(r)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM);
	dependent after closeR_WriterTestW(Writer r) : WriterTestW_closeR(r) {
		Object obj = null;
		WriterTestWMonitorPM monitor = null;
		Map m = WriterTestW_r_Map;
		if (m == null) m = WriterTestW_r_Map = makeMap(r);
		synchronized(WriterTestW_r_Map){
			obj = m.get(r);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestWMonitorPM)monitors.next();
					{
						monitor.closeR(r);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut WriterTestW_writeS(Writer s) :  call(* Writer+.write*(..))&& target(s)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM) ||  call(* Writer+.print*(..))&& target(s)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM);
	dependent before writeS_WriterTestW(Writer s): WriterTestW_writeS(s) {
		Object obj = null;
		WriterTestWMonitorPM monitor = null;
		Map m = WriterTestW_s_Map;
		if (m == null) m = WriterTestW_s_Map = makeMap(s);
		synchronized(WriterTestW_s_Map){
			obj = m.get(s);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestWMonitorPM)monitors.next();
					{
						monitor.writeS(s);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut WriterTestW_writeR(Writer r) :  call(* Writer+.write*(..))&& target(r)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM) ||  call(* Writer+.print*(..))&& target(r)&& !within(dacapo..*)&& !within(WriterTest)&& !within(WriterTestWMonitor)&& !within(WriterTestWMonitorPM);
	dependent before writeR_WriterTestW(Writer r): WriterTestW_writeR(r) {
		Object obj = null;
		WriterTestWMonitorPM monitor = null;
		Map m = WriterTestW_r_Map;
		if (m == null) m = WriterTestW_r_Map = makeMap(r);
		synchronized(WriterTestW_r_Map){
			obj = m.get(r);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (WriterTestWMonitorPM)monitors.next();
					{
						monitor.writeR(r);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	//Validation dependencies
	dependency{
		strong create_WriterTestW , closeS_WriterTestW , writeS_WriterTestW ;
		weak closeR_WriterTestW , writeR_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeS_WriterTestW , writeR_WriterTestW ;
		weak closeR_WriterTestW , writeS_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeR_WriterTestW , writeS_WriterTestW ;
		weak closeS_WriterTestW , writeR_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeR_WriterTestW , writeR_WriterTestW ;
		weak closeS_WriterTestW , writeS_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeS_WriterTestW , closeR_WriterTestW , writeS_WriterTestW ;
		weak writeR_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeS_WriterTestW , closeR_WriterTestW , writeR_WriterTestW ;
		weak writeS_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeS_WriterTestW , writeS_WriterTestW , writeR_WriterTestW ;
		weak closeR_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeR_WriterTestW , writeS_WriterTestW , writeR_WriterTestW ;
		weak closeS_WriterTestW ;
	}
	dependency{
		strong create_WriterTestW , closeS_WriterTestW , closeR_WriterTestW , writeS_WriterTestW , writeR_WriterTestW ;
	}
}
