/* Monitor aspect for FailSafeIter2+*/
import java.util.*;
import org.apache.commons.collections.map.*;
class FailSafeIterMonitorPM {
	Vector monitorList = new Vector();
	synchronized public void create(Iterator i, Collection v) {
		HashSet monitorSet = new HashSet();
		monitorList.add(new FailSafeIterMonitor());
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			FailSafeIterMonitor monitor = (FailSafeIterMonitor)it.next();
			monitor.create(i, v);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("the collection is changed during iterating!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void updatesource(Collection v) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			FailSafeIterMonitor monitor = (FailSafeIterMonitor)it.next();
			monitor.updatesource(v);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("the collection is changed during iterating!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void next(Iterator i) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			FailSafeIterMonitor monitor = (FailSafeIterMonitor)it.next();
			monitor.next(i);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("the collection is changed during iterating!");
				}
			} // for else
		} // for while
	} // end of method
}
class FailSafeIterMonitor {
	int state = 1;
	boolean failed = false;
	boolean suceeded = false;
	public FailSafeIterMonitor() {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
	}
	synchronized public void create(Iterator i, Collection v) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		create = true;
		switch (state) {
			case 1:
			state =  create ? updatesource ? 3 : 2 : -2;
			break ;
			case 2:
			state =  updatesource ? 3 : 2;
			break ;
			case 3:
			state =  next ? -1 : updatesource ? 3 : 2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public void updatesource(Collection v) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		updatesource = true;
		switch (state) {
			case 1:
			state =  create ? updatesource ? 3 : 2 : -2;
			break ;
			case 2:
			state =  updatesource ? 3 : 2;
			break ;
			case 3:
			state =  next ? -1 : updatesource ? 3 : 2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public void next(Iterator i) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		next = true;
		switch (state) {
			case 1:
			state =  create ? updatesource ? 3 : 2 : -2;
			break ;
			case 2:
			state =  updatesource ? 3 : 2;
			break ;
			case 3:
			state =  next ? -1 : updatesource ? 3 : 2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public boolean suceeded(){
		return suceeded;
	}
	synchronized public void reset(){
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		state = 1;
	}
}
public aspect FailSafeIter {
	Map makeMap(int flag){
		if (flag == 1)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	Map makeMap(Object key){
		if (key instanceof String)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	List makeList(){
		return new ArrayList();
	}
	Map FailSafeIter_i_v_Map =  makeMap(0);
	Map FailSafeIter_v_Map =  makeMap(0);
	Map FailSafeIter_i_Map =  makeMap(0);
	pointcut FailSafeIter_create(Collection v) :  call(Iterator Collection+.iterator())&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor)&& !within(FailSafeIterMonitorPM);
	dependent after create_FailSafeIter(Collection v)  returning(Iterator i): FailSafeIter_create(v) {
		Object obj = null;
		FailSafeIterMonitorPM monitor = null;
		boolean toCreate = false;
		Map m = FailSafeIter_i_v_Map;
		synchronized(FailSafeIter_i_v_Map){
			obj = m.get(i);
			if (obj == null) {
				obj = makeMap(v);
				m.put(i, obj);
			}
			m = (Map)obj;
			obj = m.get(v);
			monitor = (FailSafeIterMonitorPM)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new FailSafeIterMonitorPM();
				m.put(v, monitor);
			}//end of if
		}//end of lookup
		if (toCreate){
			m = FailSafeIter_v_Map;
			obj = null;
			synchronized(FailSafeIter_v_Map){
				obj = m.get(v);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(v, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
			m = FailSafeIter_i_Map;
			obj = null;
			synchronized(FailSafeIter_i_Map){
				obj = m.get(i);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(i, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
		}//end of if
		{
			monitor.create(i, v);
		}
	}
	pointcut FailSafeIter_updatesource(Collection v) :  call(* Collection+.remove*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor)&& !within(FailSafeIterMonitorPM) ||  call(* Collection+.add*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor)&& !within(FailSafeIterMonitorPM) ||  call(* Collection+.clear())&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor)&& !within(FailSafeIterMonitorPM) ||  call(* Collection+.retainAll(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor)&& !within(FailSafeIterMonitorPM);
	dependent before updatesource_FailSafeIter(Collection v): FailSafeIter_updatesource(v) {
		Object obj = null;
		FailSafeIterMonitorPM monitor = null;
		Map m = FailSafeIter_v_Map;
		synchronized(FailSafeIter_v_Map){
			obj = m.get(v);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (FailSafeIterMonitorPM)monitors.next();
					{
						monitor.updatesource(v);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut FailSafeIter_next(Iterator i) :  call(Object Iterator+.next())&& target(i)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor)&& !within(FailSafeIterMonitorPM);
	dependent before next_FailSafeIter(Iterator i): FailSafeIter_next(i) {
		Object obj = null;
		FailSafeIterMonitorPM monitor = null;
		Map m = FailSafeIter_i_Map;
		synchronized(FailSafeIter_i_Map){
			obj = m.get(i);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (FailSafeIterMonitorPM)monitors.next();
					{
						monitor.next(i);
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	//Validation dependencies
	dependency{
		strong create_FailSafeIter , updatesource_FailSafeIter , next_FailSafeIter ;
	}
}
