/* Monitor aspect for LeakingSync2+*/
import java.util.*;
import org.apache.commons.collections.map.*;
class LeakingSyncCMonitorPM {
	Vector monitorList = new Vector();
	synchronized public void sync(Collection o) {
		HashSet monitorSet = new HashSet();
		monitorList.add(new LeakingSyncCMonitor());
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			LeakingSyncCMonitor monitor = (LeakingSyncCMonitor)it.next();
			monitor.sync(o);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void asyncCall(Collection o) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			LeakingSyncCMonitor monitor = (LeakingSyncCMonitor)it.next();
			monitor.asyncCall(o);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
				}
			} // for else
		} // for while
	} // end of method
}
class LeakingSyncCMonitor {
	int state = 1;
	boolean failed = false;
	boolean suceeded = false;
	public LeakingSyncCMonitor() {
		boolean sync = false;
		boolean asyncCall = false;
	}
	synchronized public void sync(Collection o) {
		boolean sync = false;
		boolean asyncCall = false;
		sync = true;
		switch (state) {
			case 1:
			state =  sync ? 2 : -2;
			break ;
			case 2:
			state =  asyncCall ? -1 : -2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public void asyncCall(Collection o) {
		boolean sync = false;
		boolean asyncCall = false;
		asyncCall = true;
		switch (state) {
			case 1:
			state =  sync ? 2 : -2;
			break ;
			case 2:
			state =  asyncCall ? -1 : -2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public boolean suceeded(){
		return suceeded;
	}
	synchronized public void reset(){
		boolean sync = false;
		boolean asyncCall = false;
		state = 1;
	}
}
class LeakingSyncMMonitorPM {
	Vector monitorList = new Vector();
	synchronized public void sync(Map o) {
		HashSet monitorSet = new HashSet();
		monitorList.add(new LeakingSyncMMonitor());
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			LeakingSyncMMonitor monitor = (LeakingSyncMMonitor)it.next();
			monitor.sync(o);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
				}
			} // for else
		} // for while
	} // end of method
	synchronized public void asyncCall(Map o) {
		HashSet monitorSet = new HashSet();
		Iterator it = monitorList.iterator();
		while (it.hasNext()){
			LeakingSyncMMonitor monitor = (LeakingSyncMMonitor)it.next();
			monitor.asyncCall(o);
			if (monitorSet.contains(monitor) || monitor.failed())
			it.remove();
			else {
				monitorSet.add(monitor);
				if (monitor.suceeded()){
					//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
				}
			} // for else
		} // for while
	} // end of method
}
class LeakingSyncMMonitor {
	int state = 1;
	boolean failed = false;
	boolean suceeded = false;
	public LeakingSyncMMonitor() {
		boolean sync = false;
		boolean asyncCall = false;
	}
	synchronized public void sync(Map o) {
		boolean sync = false;
		boolean asyncCall = false;
		sync = true;
		switch (state) {
			case 1:
			state =  sync ? 2 : -2;
			break ;
			case 2:
			state =  asyncCall ? -1 : -2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public void asyncCall(Map o) {
		boolean sync = false;
		boolean asyncCall = false;
		asyncCall = true;
		switch (state) {
			case 1:
			state =  sync ? 2 : -2;
			break ;
			case 2:
			state =  asyncCall ? -1 : -2;
			break ;
		}
		failed = state == -2;
		suceeded = state == -1;
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public boolean suceeded(){
		return suceeded;
	}
	synchronized public void reset(){
		boolean sync = false;
		boolean asyncCall = false;
		state = 1;
	}
}
public aspect LeakingSync {
	Map makeMap(Object key){
		if (key instanceof String)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	List makeList(){
		return new ArrayList();
	}
	Map LeakingSyncC_o_Map = null;
	pointcut LeakingSyncC_sync(Collection o) :  call(* Collections.synchr*(Collection+))&& args(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncMMonitor)&& !within(LeakingSyncMMonitorPM) && !within(LeakingSyncCMonitor)&& !within(LeakingSyncCMonitorPM);
	dependent after sync_LeakingSyncC(Collection o) returning: LeakingSyncC_sync(o) {
		Object obj = null;
		LeakingSyncCMonitorPM monitor = null;
		boolean toCreate = false;
		Map m = LeakingSyncC_o_Map;
		if (m == null) m = LeakingSyncC_o_Map = makeMap(o);
		synchronized(LeakingSyncC_o_Map){
			obj = m.get(o);
			monitor = (LeakingSyncCMonitorPM)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new LeakingSyncCMonitorPM();
				m.put(o, monitor);
			}//end of if
		}//end of lookup
		{
			monitor.sync(o);
		}
	}
	pointcut LeakingSyncC_asyncCall(Collection o) :  call(* Collection+.*(..))&& target(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncMMonitor)&& !within(LeakingSyncMMonitorPM) && !within(LeakingSyncCMonitor)&& !within(LeakingSyncCMonitorPM);
	dependent before asyncCall_LeakingSyncC(Collection o): LeakingSyncC_asyncCall(o) {
		Object obj = null;
		LeakingSyncCMonitorPM monitor = null;
		Map m = LeakingSyncC_o_Map;
		if (m == null) m = LeakingSyncC_o_Map = makeMap(o);
		synchronized(LeakingSyncC_o_Map){
			obj = m.get(o);
		}//end of lookup
		monitor = (LeakingSyncCMonitorPM)obj;
		if (monitor != null) {
			monitor.asyncCall(o);
		}//end if
	}
	//Validation dependencies
	dependency{
		strong sync_LeakingSyncC , asyncCall_LeakingSyncC ;
	}
	Map LeakingSyncM_o_Map = null;
	pointcut LeakingSyncM_sync(Map o) :  call(* Collections.synchr*(Map+))&& args(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncMMonitor)&& !within(LeakingSyncMMonitorPM) && !within(LeakingSyncCMonitor)&& !within(LeakingSyncCMonitorPM);
	dependent after sync_LeakingSyncM(Map o) returning: LeakingSyncM_sync(o) {
		Object obj = null;
		LeakingSyncMMonitorPM monitor = null;
		boolean toCreate = false;
		Map m = LeakingSyncM_o_Map;
		if (m == null) m = LeakingSyncM_o_Map = makeMap(o);
		synchronized(LeakingSyncM_o_Map){
			obj = m.get(o);
			monitor = (LeakingSyncMMonitorPM)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new LeakingSyncMMonitorPM();
				m.put(o, monitor);
			}//end of if
		}//end of lookup
		{
			monitor.sync(o);
		}
	}
	pointcut LeakingSyncM_asyncCall(Map o) :  call(* Map+.*(..))&& target(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncMMonitor)&& !within(LeakingSyncMMonitorPM) && !within(LeakingSyncCMonitor)&& !within(LeakingSyncCMonitorPM);
	dependent before asyncCall_LeakingSyncM(Map o): LeakingSyncM_asyncCall(o) {
		Object obj = null;
		LeakingSyncMMonitorPM monitor = null;
		Map m = LeakingSyncM_o_Map;
		if (m == null) m = LeakingSyncM_o_Map = makeMap(o);
		synchronized(LeakingSyncM_o_Map){
			obj = m.get(o);
		}//end of lookup
		monitor = (LeakingSyncMMonitorPM)obj;
		if (monitor != null) {
			monitor.asyncCall(o);
		}//end if
	}
	//Validation dependencies
	dependency{
		strong sync_LeakingSyncM , asyncCall_LeakingSyncM ;
	}
}
