/* Monitor aspect for FailSafeIter3+*/
import java.util.*;
import org.apache.commons.collections.map.*;
class FailSafeIterMonitor {
	boolean[] pre = new boolean[3];
	boolean[] now = new boolean[3];
	boolean failed = false;
	public FailSafeIterMonitor() {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		now[2] = create;
		now[1] = now[2];
		now[0] = create;
	}
	synchronized public void create(Iterator i, Collection v) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		create = true;
		pre[0] = now[0];
		pre[1] = now[1];
		pre[2] = now[2];
		now[2] = create || ! updatesource && pre[2];
		now[1] = now[2];
		now[0] = create || pre[ 0];
		failed = next && ! pre[1] && now[0];
	}
	synchronized public void updatesource(Collection v) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		updatesource = true;
		pre[0] = now[0];
		pre[1] = now[1];
		pre[2] = now[2];
		now[2] = create || ! updatesource && pre[2];
		now[1] = now[2];
		now[0] = create || pre[ 0];
		failed = next && ! pre[1] && now[0];
	}
	synchronized public void next(Iterator i) {
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		next = true;
		pre[0] = now[0];
		pre[1] = now[1];
		pre[2] = now[2];
		now[2] = create || ! updatesource && pre[2];
		now[1] = now[2];
		now[0] = create || pre[ 0];
		failed = next && ! pre[1] && now[0];
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public void reset(){
		boolean create = false;
		boolean updatesource = false;
		boolean next = false;
		now[2] = create;
		now[1] = now[2];
		now[0] = create;
	}
}
public aspect FailSafeIter {
	Map makeMap(int flag){
		if (flag == 1)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	Map makeMap(Object key){
		if (key instanceof String)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	List makeList(){
		return new ArrayList();
	}
	Map FailSafeIter_i_v_Map =  makeMap(0);
	Map FailSafeIter_v_Map =  makeMap(0);
	Map FailSafeIter_i_Map =  makeMap(0);
	pointcut FailSafeIter_create(Collection v) :  call(Iterator Collection+.iterator())&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor);
	dependent after create_FailSafeIter(Collection v)  returning(Iterator i): FailSafeIter_create(v) {
		Object obj = null;
		FailSafeIterMonitor monitor = null;
		boolean toCreate = false;
		Map m = FailSafeIter_i_v_Map;
		synchronized(FailSafeIter_i_v_Map){
			obj = m.get(i);
			if (obj == null) {
				obj = makeMap(v);
				m.put(i, obj);
			}
			m = (Map)obj;
			obj = m.get(v);
			monitor = (FailSafeIterMonitor)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new FailSafeIterMonitor();
				m.put(v, monitor);
			}//end of if
		}//end of lookup
		if (toCreate){
			m = FailSafeIter_v_Map;
			obj = null;
			synchronized(FailSafeIter_v_Map){
				obj = m.get(v);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(v, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
			m = FailSafeIter_i_Map;
			obj = null;
			synchronized(FailSafeIter_i_Map){
				obj = m.get(i);
				List monitors = (List)obj;
				if (monitors == null) {
					monitors = makeList();
					m.put(i, monitors);
				}//end of if
				monitors.add(monitor);
			}//end of adding
		}//end of if
		{
			monitor.create(i, v);
			if (monitor.failed()) {
				//System.out.println("the collection is changed during iterating!");
			}
		}
	}
	pointcut FailSafeIter_updatesource(Collection v) :  call(* Collection+.remove*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor) ||  call(* Collection+.add*(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor) ||  call(* Collection+.clear())&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor) ||  call(* Collection+.retainAll(..))&& target(v)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor);
	dependent before updatesource_FailSafeIter(Collection v): FailSafeIter_updatesource(v) {
		Object obj = null;
		FailSafeIterMonitor monitor = null;
		Map m = FailSafeIter_v_Map;
		synchronized(FailSafeIter_v_Map){
			obj = m.get(v);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (FailSafeIterMonitor)monitors.next();
					{
						monitor.updatesource(v);
						if (monitor.failed()) {
							//System.out.println("the collection is changed during iterating!");
						}
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	pointcut FailSafeIter_next(Iterator i) :  call(Object Iterator+.next())&& target(i)&& !within(dacapo..*)&& !within(FailSafeIter)&& !within(FailSafeIterMonitor);
	dependent before next_FailSafeIter(Iterator i): FailSafeIter_next(i) {
		Object obj = null;
		FailSafeIterMonitor monitor = null;
		Map m = FailSafeIter_i_Map;
		synchronized(FailSafeIter_i_Map){
			obj = m.get(i);
		}//end of lookup
		if (obj != null){
			synchronized(obj){
				Iterator monitors = ((List)obj).iterator();
				while (monitors.hasNext()) {
					monitor = (FailSafeIterMonitor)monitors.next();
					{
						monitor.next(i);
						if (monitor.failed()) {
							//System.out.println("the collection is changed during iterating!");
						}
					}
				}//end of while
			}//end of sync
		}//end of if
	}
	//Violation dependencies
	dependency{
		strong create_FailSafeIter , next_FailSafeIter , updatesource_FailSafeIter ;
	}
}
