/* Monitor aspect for LeakingSync3+*/
import java.util.*;
import org.apache.commons.collections.map.*;
class LeakingSyncCMonitor {
	boolean[] pre = new boolean[1];
	boolean[] now = new boolean[1];
	boolean failed = false;
	public LeakingSyncCMonitor() {
		boolean syncStart = false;
		boolean asyncCall = false;
		now[0] = syncStart;
	}
	synchronized public void syncStart(Collection o) {
		boolean syncStart = false;
		boolean asyncCall = false;
		syncStart = true;
		pre[0] = now[0];
		now[0] = syncStart || pre[0];
		failed = asyncCall && now[0];
	}
	synchronized public void asyncCall(Collection o) {
		boolean syncStart = false;
		boolean asyncCall = false;
		asyncCall = true;
		pre[0] = now[0];
		now[0] = syncStart || pre[0];
		failed = asyncCall && now[0];
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public void reset(){
		boolean syncStart = false;
		boolean asyncCall = false;
		now[0] = syncStart;
	}
}
class LeakingSyncMMonitor {
	boolean[] pre = new boolean[1];
	boolean[] now = new boolean[1];
	boolean failed = false;
	public LeakingSyncMMonitor() {
		boolean syncStart = false;
		boolean asyncCall = false;
		now[0] = syncStart;
	}
	synchronized public void syncStart(Map o) {
		boolean syncStart = false;
		boolean asyncCall = false;
		syncStart = true;
		pre[0] = now[0];
		now[0] = syncStart || pre[0];
		failed = asyncCall && now[0];
	}
	synchronized public void asyncCall(Map o) {
		boolean syncStart = false;
		boolean asyncCall = false;
		asyncCall = true;
		pre[0] = now[0];
		now[0] = syncStart || pre[0];
		failed = asyncCall && now[0];
	}
	synchronized public boolean failed(){
		return failed;
	}
	synchronized public void reset(){
		boolean syncStart = false;
		boolean asyncCall = false;
		now[0] = syncStart;
	}
}
public aspect LeakingSync {
	Map makeMap(Object key){
		if (key instanceof String)
		return new HashMap();
		else
		return new ReferenceIdentityMap(AbstractReferenceMap.WEAK, AbstractReferenceMap.HARD, true);
	}
	List makeList(){
		return new ArrayList();
	}
	Map LeakingSyncC_o_Map = null;
	pointcut LeakingSyncC_syncStart(Collection o) :  call(* Collections.synchr*(Collection+))&& args(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncCMonitor)&& !within(LeakingSyncCMonitorPM)&& !within(LeakingSyncMMonitor)&& !within(LeakingSyncMMonitorPM);
	dependent after syncStart_LeakingSyncC(Collection o) returning: LeakingSyncC_syncStart(o) {
		Object obj = null;
		LeakingSyncCMonitor monitor = null;
		boolean toCreate = false;
		Map m = LeakingSyncC_o_Map;
		if (m == null) m = LeakingSyncC_o_Map = makeMap(o);
		synchronized(LeakingSyncC_o_Map){
			obj = m.get(o);
			monitor = (LeakingSyncCMonitor)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new LeakingSyncCMonitor();
				m.put(o, monitor);
			}//end of if
		}//end of lookup
		{
			monitor.syncStart(o);
			if (monitor.failed()) {
				//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
			}
		}
	}
	pointcut LeakingSyncC_asyncCall(Collection o) :  call(* Collection+.*(..))&& target(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncCMonitor) && !within(LeakingSyncCMonitorPM) && !within(LeakingSyncMMonitor)&& !within(LeakingSyncMMonitorPM);
	dependent before asyncCall_LeakingSyncC(Collection o): LeakingSyncC_asyncCall(o) {
		Object obj = null;
		LeakingSyncCMonitor monitor = null;
		boolean toCreate = false;
		Map m = LeakingSyncC_o_Map;
		if (m == null) m = LeakingSyncC_o_Map = makeMap(o);
		synchronized(LeakingSyncC_o_Map){
			obj = m.get(o);
			monitor = (LeakingSyncCMonitor)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new LeakingSyncCMonitor();
				m.put(o, monitor);
			}//end of if
		}//end of lookup
		{
			monitor.asyncCall(o);
			if (monitor.failed()) {
				//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
			}
		}
	}
	//Violation dependencies
	dependency{
		strong asyncCall_LeakingSyncC , syncStart_LeakingSyncC ;
	}
	Map LeakingSyncM_o_Map = null;
	pointcut LeakingSyncM_syncStart(Map o) :  call(* Collections.synchr*(Map+))&& args(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncMMonitor) && !within(LeakingSyncCMonitorPM)&& !within(LeakingSyncCMonitor) && !within(LeakingSyncCMonitorPM);
	dependent after syncStart_LeakingSyncM(Map o) returning: LeakingSyncM_syncStart(o) {
		Object obj = null;
		LeakingSyncMMonitor monitor = null;
		boolean toCreate = false;
		Map m = LeakingSyncM_o_Map;
		if (m == null) m = LeakingSyncM_o_Map = makeMap(o);
		synchronized(LeakingSyncM_o_Map){
			obj = m.get(o);
			monitor = (LeakingSyncMMonitor)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new LeakingSyncMMonitor();
				m.put(o, monitor);
			}//end of if
		}//end of lookup
		{
			monitor.syncStart(o);
			if (monitor.failed()) {
				//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
			}
		}
	}
	pointcut LeakingSyncM_asyncCall(Map o) :  call(* Map+.*(..))&& target(o)&& !within(dacapo..*)&& !within(LeakingSync)&& !within(LeakingSyncMMonitor) && !within(LeakingSyncCMonitorPM)&& !within(LeakingSyncCMonitor) && !within(LeakingSyncCMonitorPM);
	dependent before asyncCall_LeakingSyncM(Map o): LeakingSyncM_asyncCall(o) {
		Object obj = null;
		LeakingSyncMMonitor monitor = null;
		boolean toCreate = false;
		Map m = LeakingSyncM_o_Map;
		if (m == null) m = LeakingSyncM_o_Map = makeMap(o);
		synchronized(LeakingSyncM_o_Map){
			obj = m.get(o);
			monitor = (LeakingSyncMMonitor)obj;
			toCreate = (monitor == null);
			if (toCreate){
				monitor = new LeakingSyncMMonitor();
				m.put(o, monitor);
			}//end of if
		}//end of lookup
		{
			monitor.asyncCall(o);
			if (monitor.failed()) {
				//System.out.println("Collection  was synchronized. Use synchronized instance instead!");
			}
		}
	}
	//Violation dependencies
	dependency{
		strong asyncCall_LeakingSyncM , syncStart_LeakingSyncM ;
	}
}
