import java.util.*;

/**
 * @author Nomair A. Naeem and Ondrej Lhotak
 */
public aspect FailSafeEnumHashtable {

   pointcut hashtable_update() :
    	call(* Map.put*(..)) ||
        call(* Map.putAll*(..)) ||
        call(* Map.clear()) ||
        call(* Map.remove*(..));
        /* TODO: in principle one could also update the table through
         * its key set but that would maybe be another tracematch*/

   tracematch(Hashtable ds, Enumeration e) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
	    sym create_enum after returning(e) :( (call(* Hashtable+.elements()) || call(* Hashtable+.keys())) && target(ds)) && !within(dacapo..*);
        sym call_next before :( call(Object Enumeration.nextElement()) && target(e)) && !within(dacapo..*);
        sym update_source after :( hashtable_update() && target(ds)) && !within(dacapo..*);

    	create_enum call_next* update_source+ call_next
    	{
           if(System.getProperty("TMTEST_ACTIVE")!=null) {
                System.err.println("##### Tracematch "+getClass().getName()+" matched!");
           }
    	}
    }
}

//class FailSafeEnumHashtableTest {
//    public static void main(String[] args) {
//    	Hashtable h = new Hashtable();
//    	h.put("1","2");
//    	h.put("2","3");
//    	Enumeration e = h.keys();
//    	e.nextElement();
//    	h.put("3","4");
//     	System.gc();
//     	System.runFinalization();
//     	System.gc();
//     	System.gc();
//    	e.nextElement();
//	}
//}