import java.util.*;

public aspect FailSafeIterMap {

   pointcut map_update() :
    	call(* Map.put*(..)) ||
        call(* Map.putAll*(..)) ||
        call(* Map.clear()) ||
        call(* Map.remove*(..));
        /* TODO: in principle one could also update the table through
         * its key set but that would maybe be another tracematch*/

   tracematch(Map hm, Collection c, Iterator i) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
	    sym create_set after returning(c) :( (call(* Map.values()) || call(* Map.keySet())) && target(hm)) && !within(dacapo..*);
	    sym create_iter after returning(i) :( call(* Collection.iterator()) && target(c)) && !within(dacapo..*);
        sym call_next before :( call(* Iterator.next()) && target(i)) && !within(dacapo..*);
        sym update_source after :( map_update() && target(hm)) && !within(dacapo..*);

    	create_set create_iter call_next* update_source+ call_next
    	{
           if(System.getProperty("TMTEST_ACTIVE")!=null) {
                System.err.println("##### Tracematch "+getClass().getName()+" matched!");
           }
    	}
    }
}

//class FailSafeIterMapTest {
//	public static void main(String[] args) {
//		Map h = new HashMap();
//		h.put("1","2");
//		h.put("2","3");
//		Collection v = h.values();
//		Iterator i = v.iterator();
//		i.next();
//		h.put("3","4");
//		System.gc();
//		System.runFinalization();
//		System.gc();
//		System.gc();
//		i.next();
//	}
//}